function [A, B, X, unfilteredA, unfilteredB] = solve(pRfb, pSoundsources, pTrackingParameter, pToaData, pSatData, pAppliedTemperature, pAppliedPressure, pLeapsecondsMatrix, pOffsetsParameter)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

%% Construct matrices A, B and C
[unfilteredA, unfilteredB, unfilteredC] = artoa.offsets.createCalculationTables( ...
    pRfb, ...
    pSoundsources, ...
    pTrackingParameter, ...
    pToaData, ...
    pSatData, ...
    pAppliedTemperature, ...
    pAppliedPressure, ...
    pLeapsecondsMatrix ...
);

%% Subtract all known offsets
[B] = artoa.offsets.subtractKnownOffsets( ...
    unfilteredA, ...
    unfilteredB, ...
    pOffsetsParameter.offsets ...
);

%% Subtract all known drifts
[B] = artoa.offsets.subtractKnownDrifts( ...
    unfilteredA, ...
    B, ...
    pOffsetsParameter.offsets ...
);

%% Optimize matrices for calculation
[A, unfilteredA] = artoa.offsets.filterCalculationTables( ...
    unfilteredA, ...
    pOffsetsParameter.offsets ...
    );

%% Subtract window start and soundsource reference time
B.toa = B.toa - unfilteredC.ReferenceTime;

%% Use fixed soundspeed
if pOffsetsParameter.useFixedSoundspeed
    if isempty(A)
        return; % nothing to be done, everything is given and soundspeed is fixed
    end
    
    B.toa = B.toa - A{:, 'Distances'} * (pOffsetsParameter.fixedSoundspeed / 1000);
    A.Distances = [];
end

%% Solve it!
X = B.toa \ A{:, :};

%% Apply row names to X
if isrow(X)
    X = X';
end
X = table(X, 'VariableNames', {'Value'}, 'RowNames', A.Properties.VariableNames);
% Rename Distance column to Soundspeed
varNames = X.Properties.RowNames;
for i = 1:length(varNames)
    if strcmp(varNames{i}, 'Distances')
        X.Properties.RowNames{i} = 'Soundspeed';
    end
end

end

